import { AxiosInstance } from 'axios';
import { Action, BaseStoreConfig, BaseStoreStaticConfig } from './types';
import { Task } from 'redux-saga';
import SagaRunner from './SagaRunner';
export default class BaseStore {
    static initialized: boolean;
    static sagaRunner: SagaRunner;
    static http: AxiosInstance;
    key: string;
    http: AxiosInstance;
    sagaRunner: SagaRunner;
    apiResToState: (apiRes?: any) => any;
    bindState: boolean;
    static init(baseStoreConfig?: BaseStoreStaticConfig): void;
    static reset(): void;
    constructor(baseStoreConfig?: BaseStoreConfig);
    dispatch(action: Action): Action<any>;
    runSaga(saga: () => Iterator<any>): Task;
    private processDecoratedMethods();
    private runCallWithSaga(funcName, apiConfig);
}
