import { Action } from './types';
import { SagaMiddleware } from 'redux-saga';
import { SagaOptions } from './types';
export declare type Saga = () => Iterator<any>;
declare class SagaRunner<T extends Action = Action> {
    private sagaOptions;
    private subscribes;
    private stores;
    private sagaMiddleware;
    private bindRunSaga;
    constructor(sagaOptions?: SagaOptions);
    dispatch(action: T): T;
    getState(): {
        [name: string]: any;
    };
    runSaga(saga: Saga, ...args: any[]): any;
    registerStore(key: string, store: any): void;
    unRegisterStore(key: string): void;
    useSagaMiddleware(middleware: SagaMiddleware<any>): void;
    private subscribe(callback);
    private rawRunSaga(options, saga);
}
export default SagaRunner;
